program prgalan;
{urejanje molekul cilindricnega vzorca tekocega kristala v 2D}
{cilindricni KS}
{sredina vzorca je prazna}
//uses wincrt;
//uses math;
const
//  Pi=3.141592654;
  NN=102;
  np=3;                                     {dimenzija tenzorja; tenzor velikosti 3 x 3}
  ipisi=1;                                  {nacin izpisa}

type
  mat_R = array [1..3,1..3] of double;        {realna matrika oz. tenzor}
  vek_R = array [1..3] of double;             {realni vektor}
  {mat=array[1..101,1..701] of double;}
  mat=array[1..100,1..1000] of double;
  bes=string[100];
  dean=array [1..100] of longint;          {niz za stevilo molekul v y smeri}
  alan=array [1..100] of double;

var                                         {Press: Numerical recepies}
  AAm,VVm:mat_R;
  DDv:vek_R;                            {normalni del}
  txt:text;
  ctsf,ctef:bes;
  bv,B1v,B2v,par:^mat;
  dim_r,dim_fi,meddim_r,meddim_fi:double;
  ini1,ini2,ini3,it_R:longint;
  AA,K_b_A,K_b_B,K_b_C,K_e,K_s,K_f:double;
  d_r,L_r,dim_1,tem,sb,kor,eps:double;
  B_field,B_fi,B_theta,Bf_r,Bf_fi,Bf_z:double;
  N_r,it,itmax:longint;
  N_fi:dean;
  d_fi:alan;


{ priredi(i,AAm); jacobi(AAm,3,DDv,VVm,it_R); VVm: columns contain normalised vectors of AAm}
procedure priredi(i,j:longint; var a:mat_R);
begin
  a[1,1]:=B1v^[i,j];  a[1,2]:=bv^[i,j];   a[1,3]:=0;
  a[2,1]:=bv^[i,j];   a[2,2]:=B2v^[i,j];  a[2,3]:=0;
  a[3,1]:=0;          a[3,2]:=0;          a[3,3]:=-(B1v^[i,j]+B2v^[i,j]);
end;

procedure jacobi(var a: mat_R;
                     n: longint;
                 var d: vek_R;
                 var v: mat_R;
              var nrot: longint);
label 99;
var
   j,iq,ip,i:longint;
   tresh,theta,tau,t,sm,s,h,g,c:double;
   b,z: ^vek_R;
begin
   new(b);
   new(z);
   for ip:=1 to n do
     begin
       for iq:=1 to n do v[ip,iq]:=0.0;
       v[ip,ip]:=1.0;
     end;
   for ip:=1 to n do
     begin
       b^[ip]:=a[ip,ip];
       d[ip]:=b^[ip];
       z^[ip]:=0.0;
     end;
   nrot:=0;
   for i:=1 to 50 do
     begin
       sm:=0.0;
       for ip:=1 to n-1 do
         for iq:=ip+1 to n do sm:=sm+abs(a[ip,iq]);
       if sm=0.0 then goto 99;
       if i<4 then tresh:=0.2*sm/sqr(n)
              else tresh:=0.0;
       for ip:=1 to n-1 do
         begin
           for iq:=ip+1 to n do
             begin
               g:=100.0*abs(a[ip,iq]);
               if ((i>4) and (abs(d[ip])+g=abs(d[ip]))and (abs(d[iq])+g=abs(d[iq])))
                 then a[ip,iq]:=0.0
                 else if abs(a[ip,iq]) > tresh then
                        begin
                          h:=d[iq]-d[ip];
                          if abs(h)+g=abs(h) then t:=a[ip,iq]/h
                                               else
                                                 begin
                                                   theta:=0.5*h/a[ip,iq];
                                                   t:=1.0/(abs(theta)+sqrt(1.0+sqr(theta)));
                                                   if theta<0.0 then t:=-t;
                                                 end;
                          c:=1.0/sqrt(1+sqr(t));
                          s:=t*c;
                          tau:=s/(1.0+c);
                          h:=t*a[ip,iq];
                          z^[ip]:=z^[ip]-h;
                          z^[iq]:=z^[iq]+h;
                          d[ip]:=d[ip]-h;
                          d[iq]:=d[iq]+h;
                          a[ip,iq]:=0.0;
                          for j:=1 to ip-1 do
                            begin
                              g:=a[j,ip];
                              h:=a[j,iq];
                              a[j,ip]:=g-s*(h+g*tau);
                              a[j,iq]:=h+s*(g-h*tau);
                            end;
                          for j:=ip+1 to iq-1 do
                            begin
                              g:=a[ip,j];
                              h:=a[j,iq];
                              a[ip,j]:=g-s*(h+g*tau);
                              a[j,iq]:=h+s*(g-h*tau);
                            end;
                          for j:=iq+1 to n do
                            begin
                              g:=a[ip,j];
                              h:=a[iq,j];
                              a[ip,j]:=g-s*(h+g*tau);
                              a[iq,j]:=h+s*(g-h*tau);
                            end;
                          for j:=1 to n do
                            begin
                              g:=v[j,ip];
                              h:=v[j,iq];
                              v[j,ip]:=g-s*(h+g*tau);
                              v[j,iq]:=h+s*(g-h*tau);
                            end;
                          nrot:=nrot+1;
                        end;
             end;
         end;

       for ip:=1 to n do
         begin
           b^[ip]:=b^[ip]+z^[ip];
           d[ip]:=b^[ip];
           z^[ip]:=0.0
         end;
     end;
   writeln('pause in routine JACOBI');
   writeln('50 iterations should not happen');
   readln;
99:
   dispose(z);
   dispose(b);
end;

procedure init(ini1,ini2,ini3:longint;
               var sb:double;
               var N_r:longint;var d_r:double;
               var N_fi:dean;var d_fi:alan);
               
var i,j:longint;
    ss0,kot1:double;

begin
  sb:=(3+sqrt(9-8*tem))/4;                  {za tem=0.5 je bulk=1.309017}

  N_r:=trunc(L_r/d_r);                      {maximalno stevilo molekul v x smeri}
  meddim_r:=(L_r-(N_r*dim_r))/N_r;          {modificirana medmolekulska razdalja}
  d_r:=dim_r+meddim_r;                      {dimenzija strukture v r - smeri}

  ss0:=sb*kor;                              {os ali order}

  case ini1 of

    0: {konstantno stevilo molekul na vsaki razdalji (r) od izhodisca KS}
       {molekule postavljene paralelno z x - osjo}
       {sredina KS je prazna}
      begin
                                            {stevilo molekul v fi smeri kot funkcija r koordinate}

         for i:=1 to N_r do N_fi[i]:=1+trunc((Pi*d_r)/d_fi[1]);
         for i:=1 to N_r do d_fi[i]:=(2*Pi)/N_fi[i];
         {for i:=1 to N_r do d_fi[i]:=(2*Pi*(dim_fi+(((Pi*((2*i)-1)*d_r)-(N_fi[i]*dim_fi))/N_fi[i])))/(Pi*((2*i)-1)*d_r);}

         for i:=1 to (N_r-1) do
           begin
             for j:=1 to N_fi[i] do
               begin
                 kot1:=0;
                 bv^[i,j]:=(ss0*(sin(2*kot1)))/2;
                 B1v^[i,j]:=ss0*((sqr(sin(kot1)))-1/3);
                 B2v^[i,j]:=ss0*((sqr(cos(kot1)))-1/3);
               end; {j}
           end; {i}
       end; {0}

    1: {linearno vecanje stevila molekul z razdaljo od izhodisca KS}
       {molekule postavljene paralelno z x - osjo}
       {sredina KS je prazna}
      begin
                                            {stevilo molekul v y smeri kot funkcija x koordinate}
         for i:=1 to N_r do N_fi[i]:=1+trunc((Pi*((2*i)-1)*d_r)/d_fi[1]);
         for i:=1 to N_r do d_fi[i]:=(2*Pi)/N_fi[i];
         {for i:=1 to N_r do d_fi[i]:=(2*Pi*(dim_fi+(((Pi*((2*i)-1)*d_r)-(N_fi[i]*dim_fi))/N_fi[i])))/(Pi*((2*i)-1)*d_r);}

         for i:=1 to (N_r-1) do
           begin
             for j:=1 to N_fi[i] do
               begin
                 kot1:=0;
                 bv^[i,j]:=ss0*(sin(2*kot1))/2;
                 B1v^[i,j]:=ss0*(sqr(sin(kot1))-1/3);
                 B2v^[i,j]:=ss0*(sqr(cos(kot1))-1/3);
               end; {j}
           end; {i}
       end; {1}

     2: {kvadratno vecanje stevila molekul z razdaljo od izhodisca KS}
        {molekule postavljene paralelno z x - osjo}
        {sredina KS je prazna}
       begin
                                            {stevilo molekul v y smeri kot funkcija x koordinate}
         for i:=1 to N_r do N_fi[i]:=1+trunc((Pi*d_r*((2*i)-1))/d_fi[1]);
         for i:=1 to N_r do d_fi[i]:=(2*Pi)/N_fi[i];
         {for i:=1 to N_r do d_fi[i]:=(2*Pi*(dim_fi+(((Pi*((2*i)-1)*d_r)-(N_fi[i]*dim_fi))/N_fi[i])))/(Pi*((2*i)-1)*d_r); }

         for i:=1 to (N_r-1) do
           begin
             for j:=1 to N_fi[i] do
               begin
                 kot1:=0;
                 bv^[i,j]:=ss0*(sin(2*kot1))/2;
                 B1v^[i,j]:=ss0*(sqr(sin(kot1))-1/3);
                 B2v^[i,j]:=ss0*(sqr(cos(kot1))-1/3);
               end;
           end; {j}
       end; {2}
  end;{case1}

  case ini2 of
    0: {molekule so pravokotne glede na povrsino: No.1 = Pi/2 - fi}
      begin
        for j:=1 to N_fi[N_r] do
           begin
              kot1:=(Pi/2)-(((j-1)*2*Pi)/(N_fi[N_r]));
              {writeln('kot : ',kot1);}
              {writeln('sin (2*kot) :  ', sin(2*kot1)); }
              {writeln('arcsin (sin(2*kot)) :  ', arcsin(sin(2*kot1)));}
              bv^[N_r,j]:=ss0*(Sin(2*kot1))/2;
              {writeln('arc :  ',(1/2)*arcsin(2*bv^[N_r,j]/ss0));}
              B1v^[N_r,j]:=ss0*((sqr(sin(kot1)))-1/3);
              B2v^[N_r,j]:=ss0*((sqr(cos(kot1)))-1/3);
              {readln;}
           end;
      end; {0}

    1: {molekule so pravokotne glede na povrsino: No.2 = -Pi/2 - fi}
      begin
        for j:=1 to N_fi[N_r] do
           begin
              kot1:=-(Pi/2)-(((j-1)*2*Pi)/(N_fi[N_r]));
              bv^[N_r,j]:=ss0*(sin(2*kot1))/2;
              B1v^[N_r,j]:=ss0*(sqr(sin(kot1))-1/3);
              B2v^[N_r,j]:=ss0*(sqr(cos(kot1))-1/3);
           end;
      end; {1}
    2: {molekule so vzporedne z povrsino: No.1 = - fi}
      begin
        for j:=1 to N_fi[N_r] do
           begin
             kot1:=(-1)*(((j-1)*2*Pi)/(N_fi[N_r]));;
             bv^[N_r,j]:=ss0*(sin(2*kot1))/2;
             B1v^[N_r,j]:=ss0*(sqr(sin(kot1))-1/3);
             B2v^[N_r,j]:=ss0*(sqr(cos(kot1))-1/3);
           end;
      end; {2}
    3: {molekule so vzporedne z povrsino: No.2 = Pi - fi}
      begin
        for j:=1 to N_fi[N_r] do
           begin
             kot1:=Pi-(((j-1)*2*Pi)/(N_fi[N_r]));;
             bv^[N_r,j]:=ss0*(sin(2*kot1))/2;
             B1v^[N_r,j]:=ss0*(sqr(sin(kot1))-1/3);
             B2v^[N_r,j]:=ss0*(sqr(cos(kot1))-1/3);
           end;
      end; {1}
  end;{case2}
end;

procedure iter(var it:longint);
var i,j,nap{,up,down,left,right,opposite,op_right,op_left}:longint;
    r1,r2,r3:double;
    {par:^mat;}

  function odvod1_fi (i,j:longint; par:mat):double;
  {prvi parcialni odvod po fi}
  {N_r:longint;d_r:double;N_fi:dean;d_fi:alan}
    begin
      if ((j<>1)and(j<>N_fi[i])) then odvod1_fi:=(par[i,j+1]-par[i,j-1])/(2*d_fi[i]);
      if j=1 then odvod1_fi:=(par[i,j+1]-par[i,N_fi[i]])/(2*d_fi[i]);
      if (j=N_fi[i]) then odvod1_fi:=(par[i,1]-par[i,j-1])/(2*d_fi[i]);
    end;

  function odvod2_fi (i,j:longint;par:mat):double;
  {drugi parcialni odvod po fi}
    begin
      if ((j<>1)and(j<>N_fi[i])) then odvod2_fi:=(par[i,j+1]+par[i,j-1]-2*par[i,j])/(sqr(d_fi[i]));
      if j=1 then odvod2_fi:=(par[i,j+1]+par[i,N_fi[i]]-2*par[i,j])/(sqr(d_fi[i]));
      if (j=N_fi[i]) then odvod2_fi:=(par[i,1]+par[i,j-1]-2*par[i,j])/(sqr(d_fi[i]));
    end;

  function odvod1_r (i,j:longint;par:mat):double;
  {prvi parcialni odvod po r}
    var
      ang:double;
      up,up_b,up_a:double;
      down,down_b,down_a:double;
      k:longint;

    begin
      ang:=((2*Pi)/(N_fi[i]))*(j-1);          {izhodiscni kot}
      up_b:=0;
      k:=1;
          while (up_b < ang) do
            begin
              up_b:=((2*Pi)/N_fi[i+1])*k;
              k:=k+1;
            end;

          if (k=1) then up:=par[i+1,k];

          up_b:=((2*Pi)/N_fi[i+1])*(k-2);
          up_a:=((2*Pi)/N_fi[i+1])*(k-1);

          if ((k<>1)and((k-1)<N_fi[i+1])) then up:=((up_a-ang)/d_fi[i+1])*par[i+1,k]+((ang-up_b)/d_fi[i+1])*par[i+1,k-1];
          if ((k<>1)and((k-1)=N_fi[i+1])) then up:=((up_a-ang)/d_fi[i+1])*par[i+1,1]+((ang-up_b)/d_fi[i+1])*par[i+1,k-1];

      if (i<>1) then
        begin
          down_b:=0;
          k:=1;
          while (down_b < ang) do
            begin
              down_b:=((2*Pi)/N_fi[i-1])*k;
              k:=k+1;
            end;

          if (k=1) then down:=par[i-1,k];

          down_b:=((2*Pi)/N_fi[i-1])*(k-2);
          down_a:=((2*Pi)/N_fi[i-1])*(k-1);

          if ((k<>1)and((k-1)<N_fi[i-1])) then down:=((down_a-ang)/d_fi[i-1])*par[i-1,k]+((ang-down_b)/d_fi[i-1])*par[i-1,k-1];
          if ((k<>1)and((k-1)=N_fi[i-1])) then down:=((down_a-ang)/d_fi[i-1])*par[i-1,1]+((ang-down_b)/d_fi[i-1])*par[i-1,k-1];
        end;
      if (i=1) then down:=par[i,j];
      {if (i=1) then
        begin
          ang:=ang+Pi;
          if (ang>(2*Pi)) then ang:=ang-(2*Pi);
          down_b:=0;
          k:=1;
          while (down_b < ang) do
            begin
              down_b:=((2*Pi)/N_fi[i-1])*k;
              k:=k+1;
            end;

          if (k=1) then down:=par[i-1,k];

          down_b:=((2*Pi)/N_fi[i-1])*(k-2);
          down_a:=((2*Pi)/N_fi[i-1])*(k-1);

          if ((k<>1)and((k-1)<N_fi[i-1])) then down:=((down_a-ang)/d_fi[i-1])*par[i-1,k]+((ang-down_b)/d_fi[i-1])*par[i-1,k-1];
          if ((k<>1)and((k-1)=N_fi[i-1])) then down:=((down_a-ang)/d_fi[i-1])*par[i-1,1]+((ang-down_b)/d_fi[i-1])*par[i-1,k-1];
        end;}
      odvod1_r:=(up-down)/(2*d_r);
    end;

    function odvod2_r (i,j:longint;par:mat):double;
  {drugi parcialni odvod po r}
    var
      up,up_b,up_a:double;
      down,down_b,down_a:double;
      ang:double;
      k:longint;
    begin
      ang:=((2*Pi)/(N_fi[i]))*(j-1);          {izhodiscni kot}
      up_b:=0;
      k:=1;
          while (up_b < ang) do
            begin
              up_b:=((2*Pi)/N_fi[i+1])*k;
              k:=k+1;
            end;

          if (k=1) then up:=par[i+1,k];

          up_b:=((2*Pi)/N_fi[i+1])*(k-2);
          up_a:=((2*Pi)/N_fi[i+1])*(k-1);

          if ((k<>1)and((k-1)<N_fi[i+1])) then up:=((up_a-ang)/d_fi[i+1])*par[i+1,k]+((ang-up_b)/d_fi[i+1])*par[i+1,k-1];
          if ((k<>1)and((k-1)=N_fi[i+1])) then up:=((up_a-ang)/d_fi[i+1])*par[i+1,1]+((ang-up_b)/d_fi[i+1])*par[i+1,k-1];

       if (i<>1) then
        begin
          down_b:=0;
          k:=1;
          while (down_b < ang) do
            begin
              down_b:=((2*Pi)/N_fi[i-1])*k;
              k:=k+1;
            end;

          if (k=1) then down:=par[i-1,k];

          down_b:=((2*Pi)/N_fi[i-1])*(k-2);
          down_a:=((2*Pi)/N_fi[i-1])*(k-1);

          if ((k<>1)and((k-1)<N_fi[i-1])) then down:=((down_a-ang)/d_fi[i-1])*par[i-1,k]+((ang-down_b)/d_fi[i-1])*par[i-1,k-1];
          if ((k<>1)and((k-1)=N_fi[i-1])) then down:=((down_a-ang)/d_fi[i-1])*par[i-1,1]+((ang-down_b)/d_fi[i-1])*par[i-1,k-1];
        end;

      if (i=1) then down:=par[i,j];
      {if (i=1) then
        begin
          ang:=ang+Pi;
          if (ang>(2*Pi)) then ang:=ang-(2*Pi);
          down_b:=0;
          k:=1;
          while (down_b < ang) do
            begin
              down_b:=((2*Pi)/N_fi[i-1])*k;
              k:=k+1;
            end;

          if (k=1) then down:=par[i-1,k];

          down_b:=((2*Pi)/N_fi[i-1])*(k-2);
          down_a:=((2*Pi)/N_fi[i-1])*(k-1);

          if ((k<>1)and((k-1)<N_fi[i-1])) then down:=((down_a-ang)/d_fi[i-1])*par[i-1,k]+((ang-down_b)/d_fi[i-1])*par[i-1,k-1];
          if ((k<>1)and((k-1)=N_fi[i-1])) then down:=((down_a-ang)/d_fi[i-1])*par[i-1,1]+((ang-down_b)/d_fi[i-1])*par[i-1,k-1];
          }
      odvod2_r:=(up+down-2*par[i,j])/(sqr(d_r));
    end;

  function odvod2_rfi (i,j:longint;par:mat):double;
  {drugi mesani parcialni odvod po r in fi}
    var
      up_b,up_a,up_bb,up_ba,up_ab,up_aa:double;
      down_b,down_a,down_bb,down_ba,down_ab,down_aa:double;
      ang:double;
      k:longint;
    begin
      ang:=((2*Pi)/(N_fi[i]))*(j-1);          {izhodiscni kot}
      ang:=ang+d_fi[i+1];
      if (ang<0) then ang:=ang+(2*Pi);
      if (ang>(2*Pi)) then ang:=ang-(2*Pi);
      up_ab:=0;
      k:=1;
          while (up_ab < ang) do
            begin
              up_ab:=((2*Pi)/N_fi[i+1])*k;
              k:=k+1;
            end;
          if (k=1) then up_a:=par[i+1,k];
          up_ab:=((2*Pi)/N_fi[i+1])*(k-2);
          up_aa:=((2*Pi)/N_fi[i+1])*(k-1);
          if ((k<>1)and((k-1)<N_fi[i+1])) then up_a:=((up_aa-ang)/d_fi[i+1])*par[i+1,k]+((ang-up_ab)/d_fi[i+1])*par[i+1,k-1];
          if ((k<>1)and((k-1)=N_fi[i+1])) then up_a:=((up_aa-ang)/d_fi[i+1])*par[i+1,1]+((ang-up_ab)/d_fi[i+1])*par[i+1,k-1];

      ang:=((2*Pi)/(N_fi[i]))*(j-1);          {izhodiscni kot}
      ang:=ang-d_fi[i+1];
      if (ang<0) then ang:=ang+(2*Pi);
      if (ang>(2*Pi)) then ang:=ang-(2*Pi);
      up_bb:=0;
      k:=1;
          while (up_bb < ang) do
            begin
              up_bb:=((2*Pi)/N_fi[i+1])*k;
              k:=k+1;
            end;

          if (k=1) then up_b:=par[i+1,k];

          up_bb:=((2*Pi)/N_fi[i+1])*(k-2);
          up_ba:=((2*Pi)/N_fi[i+1])*(k-1);

          if ((k<>1)and((k-1)<N_fi[i+1])) then up_b:=((up_ba-ang)/d_fi[i+1])*par[i+1,k]+((ang-up_bb)/d_fi[i+1])*par[i+1,k-1];
          if ((k<>1)and((k-1)=N_fi[i+1])) then up_b:=((up_ba-ang)/d_fi[i+1])*par[i+1,1]+((ang-up_bb)/d_fi[i+1])*par[i+1,k-1];


      if (i<>1) then
        begin
          ang:=((2*Pi)/(N_fi[i]))*(j-1);          {izhodiscni kot}
          ang:=ang+d_fi[i-1];
          if (ang<0) then ang:=ang+(2*Pi);
          if (ang>(2*Pi)) then ang:=ang-(2*Pi);
          down_ab:=0;
          k:=1;
            while (down_ab < ang) do
              begin
                down_ab:=((2*Pi)/N_fi[i-1])*k;
                k:=k+1;
              end;

            if (k=1) then down_a:=par[i-1,k];

            down_ab:=((2*Pi)/N_fi[i-1])*(k-2);
            down_aa:=((2*Pi)/N_fi[i-1])*(k-1);

            if ((k<>1)and((k-1)<N_fi[i-1])) then down_a:=((down_aa-ang)/d_fi[i-1])*par[i-1,k]+((ang-down_ab)/d_fi[i-1])*par[i-1,k-1];
            if ((k<>1)and((k-1)=N_fi[i-1])) then down_a:=((down_aa-ang)/d_fi[i-1])*par[i-1,1]+((ang-down_ab)/d_fi[i-1])*par[i-1,k-1];

          ang:=((2*Pi)/(N_fi[i]))*(j-1);          {izhodiscni kot}
          ang:=ang-d_fi[i-1];
          if (ang<0) then ang:=ang+(2*Pi);
          if (ang>(2*Pi)) then ang:=ang-(2*Pi);
          down_bb:=0;
          k:=1;
            while (down_bb < ang) do
              begin
                down_bb:=((2*Pi)/N_fi[i-1])*k;
                k:=k+1;
              end;

            if (k=1) then down_b:=par[i-1,k];

            down_bb:=((2*Pi)/N_fi[i-1])*(k-2);
            down_ba:=((2*Pi)/N_fi[i-1])*(k-1);

            if ((k<>1)and((k-1)<N_fi[i-1])) then down_b:=((down_ba-ang)/d_fi[i-1])*par[i-1,k]+((ang-down_bb)/d_fi[i-1])*par[i-1,k-1];
            if ((k<>1)and((k-1)=N_fi[i-1])) then down_b:=((down_ba-ang)/d_fi[i-1])*par[i-1,1]+((ang-down_bb)/d_fi[i-1])*par[i-1,k-1];
        end;

      if (i=1) then
        begin
          if (j=1) then down_b:=par[i,N_fi[i]]
                   else down_b:=par[i,j-1];
          if (j=N_fi[i]) then down_a:=par[i,1]
                         else down_a:=par[i,j+1];
        end;

      odvod2_rfi:=(up_a+down_b-up_b-down_a)/(4*d_r*d_fi[i]);
    end;

  function meja(i,j:longint;par:mat):double;
  {iskanje soseda na meji}
    var
      up_b,up_a:double;
      ang:double;
      k:longint;
    begin
      ang:=((2*Pi)/(N_fi[i]))*(j-1);          {izhodiscni kot}
      up_b:=0;
      k:=1;
          while (up_b < ang) do
            begin
              up_b:=((2*Pi)/N_fi[i+1])*k;
              k:=k+1;
            end;

          if (k=1) then meja:=par[i+1,k];

          up_b:=((2*Pi)/N_fi[i+1])*(k-2);
          up_a:=((2*Pi)/N_fi[i+1])*(k-1);

          if ((k<>1)and((k-1)<N_fi[i+1])) then meja:=((up_a-ang)/d_fi[i+1])*par[i+1,k]+((ang-up_b)/d_fi[i+1])*par[i+1,k-1];
          if ((k<>1)and((k-1)=N_fi[i+1])) then meja:=((up_a-ang)/d_fi[i+1])*par[i+1,1]+((ang-up_b)/d_fi[i+1])*par[i+1,k-1];
    end;

  procedure f_b(i,j:longint; var rr:double; var np:longint);
  var brr,bfifi,B1rfi,B2rfi,B2fir,B2fi,bulk,ele,dele,b,B1,B2:double;
    begin

      b:=bv^[i,j];
      B1:=B1v^[i,j];
      B2:=B2v^[i,j];
      brr:=odvod2_r(i,j,bv^);
      bfifi:=odvod2_fi(i,j,bv^);
      B2fi:=odvod1_fi(i,j,B2v^);
      B1rfi:=odvod2_rfi(i,j,B1v^);
      B2rfi:=odvod2_rfi(i,j,B2v^);
      B2fir:=B2rfi;
      {bulk:=6*b*(6*sqr(b)-(9/2)*B1+6*sqr(B1)-(9/2)*B2+6*B1*B2+6*sqr(B2)+tem);}
      bulk:=4*K_b_A*b-6*K_b_B*b*B1-6*K_b_B*b*B2+16*K_b_C*b*b*b+16*K_b_C*b*B1*B1+16*K_b_C*b*B2*B2+16*K_b_C*b*B1*B2;
      {ele:=bulk-2*K_e*(brr+(1/((((2*i)-1)/2)*d_r))*(B1rfi+B2fir)+(1/sqr((((2*i)-1)/2)*d_r))*(bfifi-B2fi))-K_f*Bf_r*Bf_fi;}
      ele:=bulk+2*K_s*b+K_f*Bf_r*Bf_fi-2*K_e*(brr+((1/sqr((((2*i)-1)/2)*d_r))*(B2fi+bfifi))-((1/((((2*i)-1)/2)*d_r))*(B2fir+B1rfi)));
      if (i=(N_r-1)) then ele:=ele-2*K_s*meja(i,j,bv^);
      {dele:=6*((6*sqr(b))-(9*B1)+(6*sqr(B1))-(9*B2)+(6*B1*B2)+(6*sqr(B2))+tem)+(72*sqr(b))
            +4*K_e*((1/sqr(d_r))+(1/sqr((((2*i)-1)/2)*d_r ))*(1/(sqr(d_fi[i]))));}
      dele:=4*K_b_A-6*K_b_B*B1-6*K_b_B*B2+48*K_b_C*(sqr(b))+16*K_b_C*(sqr(B1))+16*K_b_C*(sqr(B2))+16*K_b_C*B1*B2+2*K_s
             +4*K_e*((1/sqr(d_r))+(1/sqr((((2*i)-1)/2)*d_r ))*(1/(sqr(d_fi[i]))));
      if dele<>0 then rr:=bv^[i,j]-AA*(ele/dele)
                 else rr:=bv^[i,j];
      if abs(rr-bv^[i,j])>eps then np:=np+1;
    end;

  procedure f_B1(i,j:longint; var rr:double; var np:longint);
  var bfi,brfi,bfir,B1rr,bulk,ele,dele,b,B1,B2:double;
    begin
      b:=bv^[i,j];
      B1:=B1v^[i,j];
      B2:=B2v^[i,j];

      B1rr:=odvod2_r(i,j,B1v^);
      bfi:=odvod1_fi(i,j,bv^);
      brfi:=odvod2_rfi(i,j,bv^);
      bfir:=brfi;

      {bulk:=3*((-9/2)*sqr(b)+12*sqr(b)*B1+12*B1*B1*B1+6*sqr(b)*B2+9*B1*B2+
           18*sqr(B1)*B2+(9/2)*sqr(B2)+18*B1*sqr(B2)-6*B2*B2*B2+2*B1*tem+B2*tem);}
      bulk:=4*K_b_A*B1+4*K_b_A*B2-3*K_b_B*(sqr(b))+6*K_b_B*B1*B2+3*K_b_B*(sqr(B2))
            +16*K_b_C*B1*B1*B1+24*K_b_C*(sqr(B1))*B2+8*K_b_C*B2*B2*B2
            +24*K_b_C*B1*(sqr(B2))+16*K_b_C*B1*(sqr(b))+8*K_b_B*B2*(sqr(b));
      {ele:=bulk-2*K_e*(B1rr+(1/((((2*i)-1)/2)*d_r ))*bfir-(1/sqr((((2*i)-1)/2)*d_r ))*bfi)+(K_f/2)*((Bf_z*Bf_z)-(Bf_r*Bf_r));}
      ele:=bulk+2*K_s*B1+K_s*B2-(K_f/2)*(sqr(Bf_r))+(K_f/2)*(sqr(Bf_z))
           -2*K_e*(B1rr+(1/((((2*i)-1)/2)*d_r ))*bfir-(1/sqr((((2*i)-1)/2)*d_r ))*bfi);
      if (i=(N_r-1)) then ele:=ele-2*K_s*meja(i,j,B1v^)-K_s*meja(i,j,B2v^);
      {dele:=36*sqr(b)+108*sqr(B1)+54*sqr(B2)+27*B2+108*B1*B2+6*tem+
           4*K_e*(1/sqr(d_r));}
      dele:=4*K_b_A+6*K_b_B*B2+48*K_b_C*(sqr(B1))+48*K_b_C*B1*B2+24*K_b_C*(sqr(B2))
            +16*K_b_C*(sqr(b))-2*K_s+4*K_e*(1/sqr(d_r));
      if dele<>0 then rr:=B1v^[i,j]-AA*(ele/dele)
                 else rr:=B1v^[i,j];
      if abs(rr-B1v^[i,j])>eps then np:=np+1;
    end;

  procedure f_B2(i,j:longint; var rr:double; var np:longint);
  var brfi,B2fifi,bulk,ele,dele,b,B1,B2:double;
    begin
      b:=bv^[i,j];
      B1:=B1v^[i,j];
      B2:=B2v^[i,j];

      B2fifi:=odvod2_fi(i,j,B2v^);
      brfi:=odvod2_rfi(i,j,bv^);

      {bulk:=3*((-9/2)*sqr(b)+6*sqr(b)*B1+(9/2)*sqr(B1)+6*B1*B1*B1+12*sqr(b)*B2+
            9*B1*B2+18*sqr(B1)*B2-18*B1*sqr(B2)+12*B2*B2*B2+2*B1*tem+2*B2*tem);}
      bulk:=4*K_b_A*B1+4*K_b_A*B2-3*K_b_B*(sqr(b))+3*K_b_B*(sqr(B1))+6*K_b_B*B1*B2
            +16*K_b_C*B2*B2*B2+8*K_b_C*B1*B1*B1+24*K_b_C*B1*(sqr(B2))+24*K_b_C*(sqr(B1))*B2
            +16*K_b_C*(sqr(b))*B2+8*K_b_C*(sqr(b))*B1;
      {ele:=bulk-(2*K_e/((((2*i)-1)/2)*d_r))*(((1/((((2*i)-1)/2)*d_r ))*B2fifi)+brfi)+(K_f/2)*((Bf_z*Bf_z)-(Bf_fi*Bf_fi));}
      ele:=bulk+2*K_s*B2+K_s*B1-(K_f/2)*(sqr(Bf_fi))+(K_f/2)*(sqr(Bf_z))
           +2*K_e*((1/sqr((((2*i)-1)/2)*d_r ))*B2fifi-(1/((((2*i)-1)/2)*d_r ))*brfi);
      if (i=(N_r-1)) then ele:=ele-2*K_s*meja(i,j,B2v^)-K_s*meja(i,j,B1v^);
      {dele:=36*sqr(b)+54*sqr(B1)+108*sqr(B2)-108*B1*B2+27*B1+6*tem+
            4*K_e*(1/sqr(d_fi[i]));}
      dele:=4*K_b_A+6*K_b_B*B1+48*K_b_C*(sqr(B2))+48*K_b_C*B1*B2+24*K_b_C*(sqr(B1))
            +16*K_b_C*(sqr(b))+2*K_s+4*K_e*(1/sqr((((2*i)-1)/2)*d_r ))*(1/sqr(d_fi[i])) ;
      if (dele<>0) then rr:=B2v^[i,j]-AA*(ele/dele)
                   else rr:=B2v^[i,j];
      if abs(rr-B2v^[i,j])>eps then np:=np+1;
    end;

begin
  it:=0;
  nap:=1;
  while ((it<itmax) and (nap>0)) do
    begin
      nap:=0;
      it:=it+1;
      for i:=1 to (N_r-1) do
        begin
          for j:=1 to (N_fi[i]) do
            begin
              f_b(i,j,r1,nap);
              bv^[i,j]:=r1;
              f_B1(i,j,r2,nap);
              B1v^[i,j]:=r2;
              f_B2(i,j,r3,nap);
              B2v^[i,j]:=r3;
              writeln ('end of zanka:',' i= ',i,' j= ',j);
            end;
        end;

      if ipisi=1 then writeln(it,' ',nap);

    end;

  if nap=0 then writeln('ok ',it)
           else writeln('error ',it);

end;

procedure pisi1;
var i,j:longint;
    x,y,prev,xx,yy,beq,bq2a,bq2,bq3a,bq3,arg,alef:double;
begin
  prev:=sb/3;
  assign(txt,ctsf);
  rewrite(txt);
  for i:=1 to N_r do
    begin
      x:=(((2*i)-1)/2)*d_r;                 {r - koordinata}
      for j:=1 to N_fi[i] do
        begin
          y:=(j-1)*d_fi[i];                 {fi - koordinata}
      {kartezicne koordinate}
          xx:=x*(cos (y));
          yy:=x*(sin (y));
     {iskanje lastnih vrednosti}
          priredi(i,j,AAm);
          jacobi(AAm,3,DDv,VVm,it_R);
     {dolocanje biaksialnosti}
          bq2a:=2*(sqr(bv^[i,j])+sqr(B1v^[i,j])+sqr(B2v^[i,j])+B1v^[i,j]*B2v^[i,j]);
          bq3a:=3*(B1v^[i,j]+B2v^[i,j])*(sqr(bv^[i,j])-B1v^[i,j]*B2v^[i,j]);
          bq2:=bq2a*bq2a*bq2a;
          bq3:=bq3a*bq3a;
          if (bq2<>0) then beq:=1-6*(bq3)/(bq2)
                      else beq:=-1;
      {dolocanje kota}
          arg:=(2*bv^[i,j])/(3*(B1v^[i,j]+B2v^[i,j]));
          alef:=(1/2)*(arcsin (arg));
          {if (B1v^[i,j]+B2v^[i,j])<>0 then arg:=(2/3)*(bv^[i,j])/(B1v^[i,j]+B2v^[i,j]);
          if (sqr(arg))<>1 then alef:=(1/2)*(arctan(arg/(sqrt(1-arg*arg))));
          if ((sqr(arg))=1)and(arg>0) then alef:=Pi/4;
          if ((sqr(arg))=1)and(arg<0) then alef:=-Pi/4;}
      {izpis v datoteko}
          writeln(txt,i,'     ',j,'     ',x,'     ',y,'     ',xx,'     ',yy,'     ',
                      bv^[i,j],'     ',B1v^[i,j],'     ',B2v^[i,j],'     ',
                      DDv[1]/prev,'     ',DDv[2]/prev,'     ',DDv[3]/prev,'     ',
                      VVm[1,1],'     ',VVm[2,1],'     ',VVm[3,1],'      ',
                      VVm[1,2],'     ',VVm[2,2],'     ',VVm[3,2],'      ',
                      VVm[1,3],'     ',VVm[2,3],'     ',VVm[3,3],'      ',
                      beq,'     ',alef);
          {writeln(txt,x:10:9,' ',y:10:9,' ',xx:10:9,' ',yy:10:9,' ',
                      DDv[1]/prev:10:5,' ',DDv[2]/prev:10:9,' ',DDv[3]/prev:10:5,' ',
                      VVm[1,1]:10:5,' ',VVm[2,1]:10:5,' ',VVm[3,1]:10:5,' ',
                      VVm[1,2]:10:5,' ',VVm[2,2]:10:5,' ',VVm[3,2]:10:5,' ',
                      VVm[1,3]:10:5,' ',VVm[2,3]:10:5,' ',VVm[3,3]:10:5,' ',
                      beq:10:5,' ',alef:10:5);}
        end;
    end;
  close(txt);
end;

procedure pisi2;
var i,j:longint;
    x,y,prev,xx,yy,beq,bq2a,bq2,bq3a,bq3,arg,alef:double;
begin
  prev:=sb/3;
  assign(txt,ctef);
  rewrite(txt);
  for i:=1 to N_r do
    begin
      x:=(((2*i)-1)/2)*d_r;
      for j:=1 to N_fi[i] do
        begin
          y:=(j-1)*d_fi[i];
      {kartezicne koordinate}
          xx:=x*(cos (y));
          yy:=x*(sin (y));
     {iskanje lastnih vrednosti}
          priredi(i,j,AAm);
          jacobi(AAm,3,DDv,VVm,it_R);
     {dolocanje biaksialnosti}
          bq2a:=2*(sqr(bv^[i,j])+sqr(B1v^[i,j])+sqr(B2v^[i,j])+B1v^[i,j]*B2v^[i,j]);
          bq3a:=3*(B1v^[i,j]+B2v^[i,j])*(sqr(bv^[i,j])-B1v^[i,j]*B2v^[i,j]);
          bq2:=bq2a*bq2a*bq2a;
          bq3:=bq3a*bq3a;
          if (bq2<>0) then beq:=1-6*(bq3)/(bq2)
                      else beq:=-1;
      {dolocanje kota}
          arg:=(2*bv^[i,j])/(3*(B1v^[i,j]+B2v^[i,j]));
          alef:=(1/2)*(arcsin (arg));
          {if (B1v^[i,j]+B2v^[i,j])<>0 then arg:=(2/3)*(bv^[i,j])/(B1v^[i,j]+B2v^[i,j]);
          if (sqr(arg))<>1 then alef:=(1/2)*(arctan(arg/(sqrt(1-arg*arg))));
          if ((sqr(arg))=1)and(arg>0) then alef:=Pi/4;
          if ((sqr(arg))=1)and(arg<0) then alef:=-Pi/4;}
      {izpis v datoteko}
          writeln(txt,i,'     ',j,'     ',x,'     ',y,'     ',xx,'     ',yy,'     ',
                      bv^[i,j],'     ',B1v^[i,j],'     ',B2v^[i,j],'     ',
                      DDv[1]/prev,'     ',DDv[2]/prev,'     ',DDv[3]/prev,'     ',
                      VVm[1,1],'     ',VVm[2,1],'     ',VVm[3,1],'      ',
                      VVm[1,2],'     ',VVm[2,2],'     ',VVm[3,2],'      ',
                      VVm[1,3],'     ',VVm[2,3],'     ',VVm[3,3],'      ',
                      beq,'     ',alef);
          {writeln(txt,xx:10:9,' ',yy:10:9,' ',
                      DDv[1]/prev:10:5,' ',DDv[2]/prev:10:5,' ',DDv[3]/prev:10:5,' ',
                      VVm[1,1]:10:5,' ',VVm[2,1]:10:5,' ',VVm[3,1]:10:5,' ',
                      VVm[1,2]:10:5,' ',VVm[2,2]:10:5,' ',VVm[3,2]:10:5,' ',
                      VVm[1,3]:10:5,' ',VVm[2,3]:10:5,' ',VVm[3,3]:10:5,' ',
                      beq:10:5,' ',alef:10:5);}
        end;
    end;
  close(txt);
end;

begin                                       {glavni program}
//  ClrScr;                                 {brisanje zaslona}

  New(bv);                                  {kreacija niza kazalcev za parameter b}
  New(B1v);                                 {kreacija niza kazalcev za parameter B1}
  New(B2v);                                 {kreacija niza kazalcev za parameter B2}
  New(par);

  assign(txt,'dean.ini');       {povezava z podatkovno datoteko}
  reset(txt);                               {priprava podatkovne datoteke za branje}

  readln(txt,ctsf);                         {datoteka za izpis zacetnih nastavitev}
  readln(txt,ctef);                         {datoteka za izpis koncnih rezultatov}
  readln(txt,AA);                           {kontrola vpliva (ele/dele) na novi = metoda over relaxation}
  readln(txt,eps);                          {zazeljena koncna diferenca med novi in stari}
  readln(txt,itmax);                        {maximalno stevilo iteracij}
  readln(txt,ini1);                         {nastavitev notranjosti vzorca}
  readln(txt,ini2);                         {nastavitev povrsine vzorca}
  readln(txt,ini3);                         {nastavitev defekta v vzorcu}
  readln(txt,kor);                          {korekcijski faktor k parametru s}
  readln(txt,tem);                          {temperatura vzorca}
  readln(txt,dim_1);                        {premer vzorca - 2 x dimenzija prve koordinate}
  readln(txt,K_b_A);                        {konstanta bulk  - A (prvi clen)}
  readln(txt,K_b_B);                        {konstanta bulk  - B (drugi clen)}
  readln(txt,K_b_C);                        {konstanta bulk  - C (tretji clen)}
  readln(txt,K_e);                          {elasticna konstanta}
  readln(txt,K_s);                          {povrsinska konstanta}
  readln(txt,K_f);                          {konstanta zunanjega polja}
  readln(txt,dim_r);                        {dimenzija molekule v r - smeri}
  readln(txt,meddim_r);                     {medmolekulska razdalja v r - smeri}
  readln(txt,dim_fi);                       {dimenzija molekule v fi - smeri}
  readln(txt,meddim_fi);                    {medmolekulska razdalja v fi - smeri}
  readln(txt,B_field);                      {velikost magnetnega polja}
  readln(txt,B_fi);                         {kot med mag. poljem in r-osjo}
  readln(txt,B_theta);                      {kot med mag. poljem in normalo}

  close(txt);                           {konec branja}

  d_r:=dim_r+meddim_r;                      {razmik med legami  v r - koordinati}
  d_fi[1]:=dim_fi+meddim_fi;                {razmik med legami v fi - koordinati}

  B_theta:=(Pi/180)*B_theta;                {pretvorba stopinj v radiane}
  B_fi:=(Pi/180)*B_fi;                      {pretvorba stopinj v radiane}
  Bf_r:=B_field*(sin (B_theta));            {r - koordinata mag. polja}
  Bf_fi:=B_fi;                              {fi - koordinata mag. polja}
  Bf_z:=B_field*(cos (B_theta));            {z - koordniata mag. polja}

  L_r:=dim_1/2;                             {velikost vzorca - njegov polmer}

  init(ini1,ini2,ini3,sb,N_r,d_r,N_fi,d_fi);{zacetna nastavitev vzorca;
                                                   ini1 = bulk
                                                   ini2 = povrsina
                                                   ini3 = kreiran defekt}


  pisi1;                                    {izpis zacetnih nastavitev vzorca}

  if itmax>0 then iter(it);                 {iteracijska zanka}

  writeln(it,' ',sb:10:5);                  {izpis korakov na zaslon}

  pisi2;                                    {izpis koncnih rezultatov}

  Dispose(bv);                              {izbris niza kazalcev za parameter b}
  Dispose(B1v);                             {izbris niza kazalcev za parameter B1}
  Dispose(B2v);                             {izbris niza kazalcev za parameter B2}
  Dispose(par);
  writeln('T H E    E N D');                {opozorilo na konec}
  readln;                                   {cakaj na odziv}
end.
